'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _get = require('lodash/get');

var _get2 = _interopRequireDefault(_get);

var _createSyntheticFormEvent = require('./utils/createSyntheticFormEvent');

var _createSyntheticFormEvent2 = _interopRequireDefault(_createSyntheticFormEvent);

var _getDataFromKey = require('./utils/getDataFromKey');

var _getDataFromKey2 = _interopRequireDefault(_getDataFromKey);

var _updateObjectData = require('./utils/updateObjectData');

var _updateObjectData2 = _interopRequireDefault(_updateObjectData);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var propTypes = {
  name: _react.PropTypes.string,
  formData: _react.PropTypes.object,
  formMeta: _react.PropTypes.object,
  onChange: _react.PropTypes.func
};

var defaultProps = {
  formData: {},
  formMeta: {}
};

var cloneData = function cloneData(name, data) {
  return _extends({}, (0, _get2.default)(data, name, {}));
};

var getTarget = function getTarget(name, value) {
  return {
    name: name,
    value: value
  };
};

var updateKey = function updateKey(name, data, value) {
  return (0, _updateObjectData2.default)(data, { target: getTarget(name, value) });
};

var handleChange = function handleChange(name, props) {
  return function (evt) {
    var event = (0, _createSyntheticFormEvent2.default)(evt);
    event.target = getTarget(name, event.formData);
    event.formData = updateKey(name, props.formData, event.formData);
    event.formMeta = updateKey(name, props.formMeta, event.formMeta);
    return props.onChange(event);
  };
};

var branch = function branch() {
  var defaultName = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 'default';
  return function (Component) {
    var BranchedForm = function (_React$Component) {
      _inherits(BranchedForm, _React$Component);

      function BranchedForm() {
        _classCallCheck(this, BranchedForm);

        return _possibleConstructorReturn(this, (BranchedForm.__proto__ || Object.getPrototypeOf(BranchedForm)).apply(this, arguments));
      }

      _createClass(BranchedForm, [{
        key: 'render',
        value: function render() {
          var name = this.props.name || defaultName;
          var formData = cloneData(name, this.props.formData);
          var formMeta = cloneData(name, this.props.formMeta);

          return _react2.default.createElement(Component, _extends({}, this.props, {
            formData: formData,
            formMeta: formMeta,
            getFormData: (0, _getDataFromKey2.default)(formData),
            getFormMeta: (0, _getDataFromKey2.default)(formMeta),
            onChange: handleChange(name, this.props)
          }));
        }
      }]);

      return BranchedForm;
    }(_react2.default.Component);

    BranchedForm.propTypes = propTypes;
    BranchedForm.defaultProps = defaultProps;
    return BranchedForm;
  };
};

exports.default = branch;