'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _get = require('lodash/get');

var _get2 = _interopRequireDefault(_get);

var _isFunction = require('lodash/isFunction');

var _isFunction2 = _interopRequireDefault(_isFunction);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var propTypes = {
  className: _react.PropTypes.string
};

var defaultProps = {
  className: ''
};

var isActive = function isActive(rule, props) {
  if ((0, _isFunction2.default)(rule)) {
    return rule(props.formData, props);
  }
  return !!(0, _get2.default)(props.formData, rule);
};

var validateEntry = function validateEntry(component, props) {
  if (Array.isArray(component)) {
    var _component = _slicedToArray(component, 2),
        Entry = _component[0],
        rule = _component[1];

    return isActive(rule, props) ? Entry : void 0;
  }
  return component;
};

var renderComponents = function renderComponents(components, props) {
  return components.map(function (component, key) {
    var Entry = validateEntry(component, props);
    return Entry ? _react2.default.createElement(Entry, _extends({}, props, { key: key })) : null;
  });
};

var collection = function collection() {
  var components = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];

  if (!Array.isArray(components)) {
    throw new Error('expect argument 1 of collection to be an array');
  }

  var FormCollection = function (_React$Component) {
    _inherits(FormCollection, _React$Component);

    function FormCollection() {
      _classCallCheck(this, FormCollection);

      return _possibleConstructorReturn(this, (FormCollection.__proto__ || Object.getPrototypeOf(FormCollection)).apply(this, arguments));
    }

    _createClass(FormCollection, [{
      key: 'render',
      value: function render() {
        var _props = this.props,
            className = _props.className,
            props = _objectWithoutProperties(_props, ['className']);

        var classes = 'rfa-collection ' + className;
        var rendered = renderComponents(components, props);

        return _react2.default.createElement(
          'div',
          { className: classes },
          rendered
        );
      }
    }]);

    return FormCollection;
  }(_react2.default.Component);

  FormCollection.propTypes = propTypes;
  FormCollection.defaultProps = defaultProps;
  return FormCollection;
};

exports.default = collection;