'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactRedux = require('react-redux');

var _get = require('lodash/get');

var _get2 = _interopRequireDefault(_get);

var _noop = require('lodash/noop');

var _noop2 = _interopRequireDefault(_noop);

var _formActions = require('./formActions');

var _formActions2 = _interopRequireDefault(_formActions);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var propTypes = {
  getReduxData: _react.PropTypes.func,
  name: _react.PropTypes.string.isRequired,
  onChange: _react.PropTypes.func,
  onReset: _react.PropTypes.func,
  onSubmit: _react.PropTypes.func
};

var defaultProps = {
  onChange: _noop2.default,
  onSubmit: _noop2.default
};

var withReduxState = function withReduxState() {
  var reducerKey = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 'forms';
  return function (Component) {
    var ComponentWithReduxState = function (_React$Component) {
      _inherits(ComponentWithReduxState, _React$Component);

      function ComponentWithReduxState() {
        var _ref;

        var _temp, _this, _ret;

        _classCallCheck(this, ComponentWithReduxState);

        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
          args[_key] = arguments[_key];
        }

        return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = ComponentWithReduxState.__proto__ || Object.getPrototypeOf(ComponentWithReduxState)).call.apply(_ref, [this].concat(args))), _this), _this.handleChange = function (syntheticFormEvent) {
          _this.props.onChange(_this.props.name, syntheticFormEvent);
        }, _this.handleReset = function () {
          _this.props.onReset(_this.props.name);
        }, _temp), _possibleConstructorReturn(_this, _ret);
      }

      _createClass(ComponentWithReduxState, [{
        key: 'render',
        value: function render() {
          var data = this.props.getReduxData(this.props.name);

          return _react2.default.createElement(Component, _extends({}, this.props, {
            formData: data.formData,
            formMeta: data.formMeta,
            name: void 0,
            onChange: this.handleChange,
            onReset: this.handleReset
          }));
        }
      }]);

      return ComponentWithReduxState;
    }(_react2.default.Component);

    ComponentWithReduxState.propTypes = propTypes;
    ComponentWithReduxState.defaultProps = defaultProps;

    var mapStateToProps = function mapStateToProps(state) {
      return {
        getReduxData: function getReduxData(name) {
          return {
            formData: (0, _get2.default)(state, [reducerKey, 'data', name, 'formData'], {}),
            formMeta: (0, _get2.default)(state, [reducerKey, 'data', name, 'formMeta'], {})
          };
        }
      };
    };

    var mapDispatchToProps = {
      onChange: _formActions2.default.update,
      onReset: _formActions2.default.reset
    };

    return (0, _reactRedux.connect)(mapStateToProps, mapDispatchToProps)(ComponentWithReduxState);
  };
};

exports.default = withReduxState;