'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _get = require('lodash/get');

var _get2 = _interopRequireDefault(_get);

var _immutabilityHelper = require('immutability-helper');

var _immutabilityHelper2 = _interopRequireDefault(_immutabilityHelper);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function getDelta(name, value) {
  return {
    $merge: _defineProperty({}, name, value)
  };
}

function getBooleanDelta(data, name) {
  var current = (0, _get2.default)(data, name, false);
  return getDelta(name, !current);
}

function updateObjectData(data, evt) {
  var bool = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;

  var name = (0, _get2.default)(evt, 'target.name');
  var value = (0, _get2.default)(evt, 'target.value');

  var delta = bool ? getBooleanDelta(data, name) : getDelta(name, value);

  return (0, _immutabilityHelper2.default)(data, delta);
}

exports.default = updateObjectData;