'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _createSyntheticFormEvent = require('./utils/createSyntheticFormEvent');

var _createSyntheticFormEvent2 = _interopRequireDefault(_createSyntheticFormEvent);

var _getDataFromKey = require('./utils/getDataFromKey');

var _getDataFromKey2 = _interopRequireDefault(_getDataFromKey);

var _updateObjectData = require('./utils/updateObjectData');

var _updateObjectData2 = _interopRequireDefault(_updateObjectData);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var propTypes = {
  formData: _react.PropTypes.object,
  formMeta: _react.PropTypes.object,
  onChange: _react.PropTypes.func
};

var defaultProps = {
  formData: {},
  formMeta: {}
};

var handleToggle = function handleToggle(_ref) {
  var formData = _ref.formData,
      formMeta = _ref.formMeta,
      onChange = _ref.onChange;
  return function (evt) {
    var event = (0, _createSyntheticFormEvent2.default)(evt, formData, formMeta);
    event.formData = (0, _updateObjectData2.default)(formData, evt, true);
    return onChange(event);
  };
};

var handleChange = function handleChange(_ref2) {
  var formData = _ref2.formData,
      formMeta = _ref2.formMeta,
      onChange = _ref2.onChange;
  return function (evt) {
    var event = (0, _createSyntheticFormEvent2.default)(evt, formData, formMeta);
    event.formData = (0, _updateObjectData2.default)(formData, evt);
    return onChange(event);
  };
};

var withProps = function withProps() {
  return function (Component) {
    var FormWithProps = function (_React$Component) {
      _inherits(FormWithProps, _React$Component);

      function FormWithProps() {
        _classCallCheck(this, FormWithProps);

        return _possibleConstructorReturn(this, (FormWithProps.__proto__ || Object.getPrototypeOf(FormWithProps)).apply(this, arguments));
      }

      _createClass(FormWithProps, [{
        key: 'render',
        value: function render() {
          return _react2.default.createElement(Component, _extends({}, this.props, {
            formData: this.props.formData,
            formMeta: this.props.formMeta,
            getFormData: (0, _getDataFromKey2.default)(this.props.formData),
            getFormMeta: (0, _getDataFromKey2.default)(this.props.formMeta),
            onChange: handleChange(this.props),
            onToggle: handleToggle(this.props)
          }));
        }
      }]);

      return FormWithProps;
    }(_react2.default.Component);

    FormWithProps.propTypes = propTypes;
    FormWithProps.defaultProps = defaultProps;
    return FormWithProps;
  };
};

exports.default = withProps;