'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _createSyntheticFormEvent = require('./utils/createSyntheticFormEvent');

var _createSyntheticFormEvent2 = _interopRequireDefault(_createSyntheticFormEvent);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var propTypes = {
  formData: _react.PropTypes.object,
  onChange: _react.PropTypes.func
};

var defaultProps = {
  formData: {}
};

var passthrough = function passthrough(data) {
  return data;
};

var applySideEffects = function applySideEffects(sideEffects, evt, props) {
  var effects = sideEffects.length > 0 ? sideEffects : [passthrough];

  return effects.reduce(function (event, fn) {
    return fn(event, props);
  }, evt);
};

var handleChange = function handleChange(sideEffects) {
  return function (props) {
    return function (evt) {
      var event = (0, _createSyntheticFormEvent2.default)(evt);
      event = applySideEffects(sideEffects, event, props);
      return props.onChange(event);
    };
  };
};

var withSideEffects = function withSideEffects() {
  for (var _len = arguments.length, sideEffects = Array(_len), _key = 0; _key < _len; _key++) {
    sideEffects[_key] = arguments[_key];
  }

  return function (Component) {
    var onChangeHandler = handleChange(sideEffects);

    var FormWithSideEffects = function (_React$Component) {
      _inherits(FormWithSideEffects, _React$Component);

      function FormWithSideEffects() {
        _classCallCheck(this, FormWithSideEffects);

        return _possibleConstructorReturn(this, (FormWithSideEffects.__proto__ || Object.getPrototypeOf(FormWithSideEffects)).apply(this, arguments));
      }

      _createClass(FormWithSideEffects, [{
        key: 'render',
        value: function render() {
          return _react2.default.createElement(Component, _extends({}, this.props, {
            onChange: onChangeHandler(this.props)
          }));
        }
      }]);

      return FormWithSideEffects;
    }(_react2.default.Component);

    FormWithSideEffects.propTypes = propTypes;
    FormWithSideEffects.defaultProps = defaultProps;
    return FormWithSideEffects;
  };
};

exports.default = withSideEffects;