'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _immutabilityHelper = require('immutability-helper');

var _immutabilityHelper2 = _interopRequireDefault(_immutabilityHelper);

var _get = require('lodash/get');

var _get2 = _interopRequireDefault(_get);

var _noop = require('lodash/noop');

var _noop2 = _interopRequireDefault(_noop);

var _isPropKeyEqual = require('./utils/isPropKeyEqual');

var _isPropKeyEqual2 = _interopRequireDefault(_isPropKeyEqual);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var propTypes = {
  formData: _react.PropTypes.object,
  formMeta: _react.PropTypes.object,
  onChange: _react.PropTypes.func,
  onSubmit: _react.PropTypes.func
};

var defaultProps = {
  formData: {},
  formMeta: {},
  onChange: _noop2.default,
  onSubmit: _noop2.default
};

var withState = function withState() {
  var defaultFormData = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var defaultFormMeta = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  return function (Component) {
    var ComponentWithState = function (_React$Component) {
      _inherits(ComponentWithState, _React$Component);

      function ComponentWithState() {
        var _ref;

        var _temp, _this, _ret;

        _classCallCheck(this, ComponentWithState);

        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
          args[_key] = arguments[_key];
        }

        return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = ComponentWithState.__proto__ || Object.getPrototypeOf(ComponentWithState)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
          formData: {},
          formMeta: {}
        }, _this.componentWillMount = function () {
          var formData = _extends({}, defaultFormData, _this.props.formData);
          var formMeta = _extends({}, defaultFormMeta, _this.props.formMeta);
          _this.setState({ formData: formData, formMeta: formMeta });
        }, _this.componentWillReceiveProps = function (nextProps) {
          _this.validateAndRefreshData('formData', nextProps);
          _this.validateAndRefreshData('formMeta', nextProps);
        }, _this.validateAndRefreshData = function (key, nextProps) {
          if ((0, _isPropKeyEqual2.default)(key, _this.props, nextProps)) {
            var data = (0, _immutabilityHelper2.default)(nextProps[key], {
              $merge: (0, _get2.default)(_this, ['state', key], {})
            });
            _this.setState(_defineProperty({}, key, data));
          }
        }, _this.handleChange = function (syntheticFormEvent) {
          _this.setState({
            formData: syntheticFormEvent.formData,
            formMeta: syntheticFormEvent.formMeta
          });
          _this.props.onChange(syntheticFormEvent);
        }, _temp), _possibleConstructorReturn(_this, _ret);
      }

      _createClass(ComponentWithState, [{
        key: 'render',
        value: function render() {
          return _react2.default.createElement(Component, _extends({}, this.props, {
            formData: this.state.formData,
            formMeta: this.state.formMeta,
            onChange: this.handleChange
          }));
        }
      }]);

      return ComponentWithState;
    }(_react2.default.Component);

    ComponentWithState.propTypes = propTypes;
    ComponentWithState.defaultProps = defaultProps;
    return ComponentWithState;
  };
};

exports.default = withState;