'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _get = require('lodash/get');

var _get2 = _interopRequireDefault(_get);

var _getDataFromKey = require('./utils/getDataFromKey');

var _getDataFromKey2 = _interopRequireDefault(_getDataFromKey);

var _withSideEffects = require('./withSideEffects');

var _withSideEffects2 = _interopRequireDefault(_withSideEffects);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var propTypes = {
  formMeta: _react.PropTypes.object
};

var passthrough = function passthrough() {
  return void 0;
};

var getErrors = function getErrors(rules, formData) {
  return rules.reduce(function (err, fn) {
    return fn(err, formData);
  }, void 0);
};

var applyValidations = function applyValidations(rules) {
  return function (event) {
    var formData = event.formData;
    var formMeta = event.formMeta;

    formMeta.errors = getErrors(rules, formData);
    event.formMeta = formMeta;

    return event;
  };
};

var withValidation = function withValidation() {
  for (var _len = arguments.length, validations = Array(_len), _key = 0; _key < _len; _key++) {
    validations[_key] = arguments[_key];
  }

  return function (Component) {
    var rules = validations.length > 0 ? validations : [passthrough];
    var validator = applyValidations(rules);
    var AppliedComponent = (0, _withSideEffects2.default)(validator)(Component);

    var ComponentWithValidation = function (_React$Component) {
      _inherits(ComponentWithValidation, _React$Component);

      function ComponentWithValidation() {
        _classCallCheck(this, ComponentWithValidation);

        return _possibleConstructorReturn(this, (ComponentWithValidation.__proto__ || Object.getPrototypeOf(ComponentWithValidation)).apply(this, arguments));
      }

      _createClass(ComponentWithValidation, [{
        key: 'render',
        value: function render() {
          var errors = (0, _get2.default)(this.props, 'formMeta.errors');

          return _react2.default.createElement(AppliedComponent, _extends({}, this.props, {
            getFormError: (0, _getDataFromKey2.default)(errors)
          }));
        }
      }]);

      return ComponentWithValidation;
    }(_react2.default.Component);

    ComponentWithValidation.propTypes = propTypes;
    return ComponentWithValidation;
  };
};

exports.default = withValidation;